"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Clone a 2D array.
 * @param array - The array to be cloned.
 */
function clone(array) {
    let rows = array.length;
    let res = Array(rows);
    for (let r = 0; r < rows; r++)
        res[r] = array[r].slice();
    return res;
}
exports.clone = clone;
/**
 * Fill an array of a specified size with a same value.
 * @param value The value used to fill an array.
 * @param count Number of times the value is repeated.
 */
function repeat(value, count) {
    var res = Array(count);
    for (var i = 0; i < count; i++)
        res[i] = value;
    return res;
}
exports.repeat = repeat;
/**
 * Return the sum of numbers in an array.
 * @param array The array to be summed.
 */
function sum(array) {
    let res = 0;
    for (var item of array)
        res += item;
    return res;
}
exports.sum = sum;
/**
 * The flatMap() method first maps each element using a mapping function,
 * then flattens the result into a new array.
 * @param array The array of items to be flattened.
 * @param selector Function that returns an array for a given item.
 */
function flatMap(array, selector) {
    return new Array().concat(...array.map(selector));
}
exports.flatMap = flatMap;
